<template>
  <div class="records" :class="themeClasses">
    <div v-if="loading">
      <table></table>
    </div>
    <div v-else>
      <table>
        <thead>
          <tr>
            <td class="col-time">{{ $t("records.desktopTable.time") }}</td>
            <td class="col-name">{{ $t("records.desktopTable.name") }}</td>
            <td class="col-state">{{ $t("records.desktopTable.state") }}</td>
            <td class="col-seated-time">
              {{ $t("records.desktopTable.seatedTime") }}
            </td>
            <td class="col-size">{{ $t("records.desktopTable.groupSize") }}</td>
            <td class="col-note">{{ $t("records.desktopTable.note") }}</td>
            <td class="col-link"></td>
          </tr>
        </thead>
        <tbody v-if="reservations.length > 0">
          <tr
            v-for="(reservation, index) in reservations"
            :key="index"
            :class="reservationClasses(reservation)"
          >
            <td v-html="datetime(reservation)"></td>
            <td class="col-name">
              <span class="col-name-wrapper">
                <span
                  class="col-name-logo"
                  :style="reservation.companyLogoStyle"
                ></span>
                <span class="col-name-detail">
                  <span class="reservation-name">{{
                    reservation.companyName
                  }}</span>
                  <span class="reservation-address">{{
                    reservation.branchAddress
                  }}</span>
                </span>
              </span>
            </td>
            <td>{{ reservation.stateLabel }}</td>
            <td v-html="seatedDatetime(reservation)"></td>
            <td>{{ $t("records.groupSize", reservation) }}</td>
            <td>{{ reservation.customerNote }}</td>
            <td>
              <a class="detail-link" :href="reservation.reservationLink">{{
                $t("records.desktopTable.link")
              }}</a>
            </td>
          </tr>
        </tbody>
      </table>
      <div class="no-records" v-if="!reservations.length">
        {{ $t(noRecordsI18nKey) }}
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  props: {
    reservations: {
      type: Array,
      default: () => []
    },
    loading: {
      type: Boolean,
      default: () => false
    },
    type: {
      type: String,
      default: () => "booking"
    }
  },

  computed: {
    ...mapGetters("theme", ["themeClasses"]),

    noRecordsI18nKey() {
      return this.type === "booking"
        ? "records.noBookingRecords"
        : "records.noWaitingRecords";
    }
  },

  methods: {
    datetime(reservation) {
      return reservation.isWaiting && reservation.state === "waiting"
        ? reservation.displayTime.fromNow()
        : reservation.displayTime.format("M/D ddd<br /> HH:mm");
    },

    seatedDatetime(reservation) {
      if (reservation.state !== "seated") {
        return "-";
      }
      return reservation.stateChangeTime.format("M/D ddd<br /> HH:mm");
    },

    reservationClasses(reservation) {
      return {
        record: true,
        cancelled: reservation.state === "cancelled"
      };
    }
  }
};
</script>

<style lang="scss" scoped>
.records table {
  font-size: 14px;
  line-height: 1.8em;
  width: 100%;
  border-collapse: collapse;
  border: 1px $color-sky-grey solid;
  white-space: nowrap;

  td {
    border: 1px $color-sky-grey solid;
    padding: 10px;
  }

  thead {
    background: $color-silver-grey;

    td {
      border-color: $color-pigeon-grey;
    }
  }

  .col-name {
    min-width: 272px;
  }

  .col-name-wrapper {
    display: flex;
    align-items: center;
    width: 100%;
  }

  .col-name-logo {
    display: inline-block;
    width: 68px;
    height: 68px;
    background-size: contain;
    background-repeat: no-repeat;
    background-position: center center;
    vertical-align: middle;
    margin-right: 15px;
    border-radius: 4px;
    flex-shrink: 0;
    flex-grow: 0;
    border: 12px transparent solid;
    box-sizing: border-box;
  }

  .col-name-detail {
    display: inline-block;
    flex-grow: 1;

    .reservation-name,
    .reservation-address {
      display: block;
    }

    .reservation-name {
      font-size: 18px;
      margin-top: 0.5em;
      margin-bottom: 0.15em;
    }

    .reservation-address {
      font-size: 13px;
      color: $color-primary-grey;
    }
  }

  .record {
    background: $color-white;

    &.cancelled {
      opacity: 0.5;
    }
  }
}

.records.theme-vip-member table {
  thead {
    background: $color-skm-gold2;
    color: $color-white;

    td {
      border-color: #aa925c;
    }
  }

  td {
    border-color: #ddcfaf;
  }

  .detail-link {
    color: $color-gold-300;
  }
}

.no-records {
  height: 120px;
  line-height: 120px;
  border: 1px $color-sky-grey solid;
  color: $color-pigeon-grey;
  font-size: 18px;
  text-align: center;
  background: $color-white;
}

.col-note {
  width: 200px;
}
</style>
